#include "gamestate.hpp"
#include <memory>
#include <string>
#include <vector>
#include <iostream>

int main(int argc, char* argv[]) {
    std::vector<std::string> args(argv, argv + argc);
    g_pEngine = std::make_unique<GameEngine>();
    for (int i = 1; i < args.size(); ++i) {
        if (args[i].compare("--no-gui") == 0) {
            g_pEngine->state.m_bNoDisplay = true;
            std::cout << "[LOG - Main] Disabling display" << std::endl;
        } else if (args[i].compare("--bot") == 0) {
            g_pEngine->state.m_bIsBotControlled = true;
            std::cout << "[LOG - Main] Bot control enabled" << std::endl;
        } else {
            std::cerr << "[ERROR] Argument " << args[i].c_str() << "not found, exiting..." << std::endl;
            return 1;
        }
    }
    g_pEngine->Start();
    return 0;
}
